Simulate Transaction on Environment Virtual TestNet
Simulate a transaction on a specific Virtual TestNet within an environment instance. State is not preserved. Supports block overrides, state overrides, and a custom block number. The richer response includes asset changes, balance changes, exposure changes, state changes, and cross-chain interop information.
Authorizations
An API key is a token that a client provides when making API calls. The key can be sent as a request header:
curl 'https://api.tenderly.co/api/v1/account/${TENDERLY_ACCOUNT_SLUG}/project/${TENDERLY_PROJECT_SLUG}/simulate' \
-H 'X-Access-Key: ${TENDERLY_ACCESS_KEY}' \
...
Learn how to generate API access tokens at Tenderly Docs.
Path Parameters
Account ID or slug
Project ID or slug
Environment ID
Environment instance ID
Virtual TestNet ID
Body
Simulation parameters
Transaction call arguments
Block number on which the transaction is simulated (hex-encoded)
"0x151924A"
Overrides for block data
{ "number": "0x124214", "time": "0x124124" }
Overrides of account state. In this mapping, the key is the address of the account, and the value contains the override.
Response
A successful response.
Result of simulating a transaction on an environment Virtual TestNet
Block number on which the simulation was executed (hex-encoded)
"0xfc497b"
Cumulative gas used up to and including this transaction in the block (hex-encoded)
"0x10"
Gas consumed by this transaction (hex-encoded)
"0xb412"
Whether the simulated transaction succeeded
true
Transaction type (hex-encoded)
"0x0"
Bloom filter of all logs emitted during simulation (hex-encoded)
"0x00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
Simulation metadata
ABI-decoded logs emitted during simulation
Execution trace call tree
Token transfers that occurred during simulation
Native ETH balance changes during simulation
Token approval and allowance changes during simulation
Account and storage state changes during simulation
Cross-chain interoperability information (only present for cross-chain simulations)